LeetCode之 Nim Game

原题如下:

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

可以从小到大对n分析:

1<=n<=3:   win

4=n:     lose

5<=n<=7:  win

8=n:     lose

....

可以发现,对于先手者来说,如果 n%4值为0,肯定输,其他情况为赢。

所以代码为下:

class Solution {
public:
    bool canWinNim(int n) {
        return n%4 != 0;
    }
};
其实也可以用博弈论中的反向归纳法来分析,结果也是一样的。需要注意在这里我们有一个很强的假设就是理性的参与者和common knowledge,这是博弈论中很重要的概念。

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值